raise "Can't run this file directly" unless defined? $lib_dir
# Net Responsibility
#
# Copyright (C) 2007 Scott Severance
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
# Author:
#	Scott Severance <http://www.scottseverance.us>

module Misc
  def check_for_root
    user = `whoami`.chomp
    unless user =~ /^root$/
      puts 'ERROR: This program must be run as root'
      exit(2)
    end
  end
  
  #returns true if no other instance exists; false otherwise
  def check_single_instance(pidfile)
    return true unless File.exists?(pidfile)
    
    # Get pid
    pid = nil
    File.open(pidfile) do |file|
      file.each {|line| pid = line.chomp }
    end
    
    # If the pidfile is stale, delete it
    #unless File.exists? "/proc/#{pid}"
    #  File.delete pidfile
    #  return false
    #end
    
    # Otherwise, kill the previous daemon
    tries = 0
    kill_str = "kill -SIGTERM #{pid}"
    begin
      tries += 1
      `#{kill_str}`
      unless $?.exitstatus == 0
        raise "Another instance of #{$0} is currently running and refuses to exit after #{tries} tries."
      end
      #File.delete(pidfile) if File.exists?(pidfile)
    rescue
      retry if tries <= 5
      raise
    end
    false
  end
end